#!/usr/bin/perl

#########################################
#                                       #
#  All right reserved (C) 2010          #
#                                       #
#  Script was written initially by Axl  #
#                                       #
#  Updated 2013 by George Ruinelli:     #
#  - Added German translation           #
#  - Added Run button                   #
#  - Improved for touchscreen           #
#                                       #
#########################################

use CGI qw(param);
use Socket;

print "Content-type: text/html\; charset=utf-8\n\n";

$version = "1.2";

if (index($ENV{HTTP_ACCEPT_LANGUAGE},"ru") == 0)
{
        $lang_title = "WakeOnLAN";
        $lang_login_error = "Ошибка авторизации";
        $lang_login_error_text = "Пожалуйста, войдите в систему под администратором, прежде чем пользоваться этим пакетом";
        $lang_enter_mac = "укажите mac адрес компьютера";
        $lang_enter_comp = "укажите название компьютера";
        $lang_enter_added = "такой mac адрес уже добавлен";
        $lang_error_mac = "неверно введен mac адрес, ";
        $lang_comp = "компьютер";
        $lang_mac = "mac адрес";
        $lang_att = "Внимание!";
        $lang_wake = "Разбудить";
        $lang_sent = "Посылается пакет на mac адрес ";
        $lang_example = "пример: ";
        $lang_example_comp = "главный сервер (юридический отдел)";
        $lang_add = "добавить";
        $lang_del = "удалить";
}
elsif (index($ENV{HTTP_ACCEPT_LANGUAGE},"de") == 0)
{
        $lang_title = "WakeOnLAN";
        $lang_login_error = "Anmeldung nötig";
        $lang_login_error_text = "Du musst dich zuerst als Admin anmelden, bevor Du diese Webseite verwenden kannst";
        $lang_enter_mac = "Gib die MAC-Adresse des Computers ein";
        $lang_enter_comp = "Gib den Namen des Computers ein";
        $lang_enter_added = "MAC-Adresse ist bereits vorhanden";
        $lang_error_mac = "Ungültige MAC-Adresse, ";
        $lang_comp = "Computer";
        $lang_mac = "MAC-Adresse";
        $lang_att = "Achtung!";
        $lang_wake = "Soll ich diesen PC aufwecken:";
        $lang_sent = "Magic Packet an MAC-Adresse gesendet";
        $lang_example = "Beispiel: ";
        $lang_example_comp = "Mein Haupt-Server";
        $lang_add = "Hinzufügen";
        $lang_del = "Löschen";
}
else
{
	$lang_title = "WakeOnLAN";
	$lang_login_error = "Login Required";
	$lang_login_error_text = "Please login as admin first, before using this webpage";
	$lang_enter_mac = "enter mac address of the computer";
	$lang_enter_comp = "enter the name of the computer";
	$lang_enter_added = "mac address is already added";
	$lang_error_mac = "incorrect mac address, ";
	$lang_comp = "computer";
	$lang_mac = "mac address";
	$lang_att = "Attention!";
	$lang_wake = "Wake";
	$lang_sent = "Sent package to mac address ";
	$lang_example = "example: ";
	$lang_example_comp = "master server (first department)";
	$lang_add = "add";
	$lang_del = "delete";
}


# Are we authenticated yet ?


if (open (IN,"/usr/syno/synoman/webman/modules/authenticate.cgi|")) {
	$user=<IN>;
	chop($user);
	close(IN);
}


# if no reply..no user...no authentication...so, bye-bye

if (!$user) {
	print "<HTML><HEAD><TITLE>".$lang_login_error."</TITLE></HEAD><BODY>".$lang_login_error_text."</BODY></HTML>\n";
	die;
}

$param_add_mac = param("add_mac"); # add new mac address
$param_add_comp = param("add_comp"); # add new computer
$param_wol_mac = param("wol_mac"); # WakeOnLAN by mac address
$param_rem_mac = param("rem_mac"); # remove computer



$config_file = "config.txt"; # config file

# if config.txt exist - loading configuration
if (-e $config_file) {
		open(conf,$config_file);
			while(<conf>)
			{
				($a_name[$i],$a_mac[$i]) = split(/\|/);
				#loading array from file, example: this is my home computer|aa:bb:cc:dd:ee:ff
				$a_index[$i] = $i;
				$i ++;
			}
}


if (($param_add_mac) || ($param_add_comp))
{

	if (!$param_add_mac)
	{
		$error = $lang_enter_mac;
		$err_copm = $param_add_comp;
	}
	elsif (!$param_add_comp)
	{
		$error = $lang_enter_comp;
		$err_mac = $param_add_mac;
	}
	else
	{
		$err = 0;
        for ($i = 0; $i<=$#a_index;)
        {
			if ($param_add_mac eq $a_mac[$i]) {$err = 1;}
			$i ++;
		}
		if ($err == 1)
		{
			$error = $lang_enter_added;
			$err_copm = $param_add_comp;
			$err_mac = $param_add_mac;
		}
		elsif ($param_add_mac !~ /[\da-f]{2}:[\da-f]{2}:[\da-f]{2}:[\da-f]{2}:[\da-f]{2}:[\da-f]{2}/i )
		{
			$error = $lang_error_mac." ".$lang_example."0a:1b:3c:4d:5e:6f";
			$err_copm = $param_add_comp;
			$err_mac = $param_add_mac;
		}
		else
		{
			$#a_index ++;
			$a_name[$#a_index] = $param_add_comp;
			$a_mac[$#a_index] = $param_add_mac;
		}
	} 
}


# update or create config and generate the javascript array of the data to be displayed
$out="";
open(conf, "> $config_file") or die "Couldn't open $config_file for writing: $!\n";
        for ($i = 0; $i<=$#a_index;)
        {
			if ($param_rem_mac ne $a_mac[$i])
			{
				print conf "$a_name[$i]|$a_mac[$i]|\r\n";
				$action="index.cgi?wol_mac=".$a_mac[$i];
				$del_str='<a href="index.cgi?rem_mac='.$a_mac[$i].'"><img src="images/delete.png" width="50" height="32" alt="'.$lang_del.' '.$a_name[$i].'" title="'.$lang_del.' '.$a_name[$i].'?" border="0"/></a>';
                                $run_str='<a href="index.cgi?wol_mac='.$a_mac[$i].'"><img src="images/run.png" width="50" height="32" alt="'.$lang_del.' '.$a_name[$i].'" title="'.$lang_wake.' '.$a_name[$i].'?" border="0"/></a>';
				if ($out) {$out.=",\n" };
				$out.="['<br><b>$a_name[$i]','$run_str','<br>$a_mac[$i]','$del_str','$action']";
			}
            $i ++;
		}
close(conf);

# HTML and javascript stuff

print  <<EOF;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

<style type="text/css">
<!--

body {
	background-color: #FFF;
	margin-top: 0px;
	margin-bottom: 0px;
	margin-left: 0px;
	margin-right: 0px;
}

body,td,th {
	color: #000;
	font-family: Verdana, Geneva, sans-serif;
	font-size: 12px;
}

#bottom {
	margin:10px;
	margin-bottom:0px;
}

#error {
	margin-left:10px;
	color:#FF0000;
	font-family: "Arial", "Helvetica", sans-serif;
	font-size: 10px;
	font-style: normal;
	font-variant: normal;
	font-weight: 400;
}

input {
	font:11px Verdana;
	width:150px;
	height:20px;
	background-color:#FFF;
	border-color:#CCC;
	border-width:1px;
	border-style:solid;
	color:#000;
	margin:10px;
}

#add_comp {
	font:11px Verdana;
	width:250px;
	height:18px;
	background-color:#FFF;
	border-color:#CCC;
	border-width:1px;
	border-style:solid;
	color:#000;
	margin:10px;
}

#add_mac {
	font:11px Verdana;
	width:150px;
	height:18px;
	background-color:#FFF;
	border-color:#CCC;
	border-width:1px;
	border-style:solid;
	color:#000;
	margin:10px;
}

#link {
	color:#000;
	font-size:11px;
	margin:10px;
}
-->
</style>

    <title>$lang_title</title>

    <!-- Include Ext and app-specific scripts: -->
    <script type="text/javascript" src="/scripts/extjs/adapter/ext/ext-base.js"></script>
    <script type="text/javascript" src="/scripts/extjs/ext-all-debug.js"></script>

EOF

# break for filling in array

print '
<script type="text/javascript">
var Computer_list = {
	init : function(){
	var myData = [' ."\n" .$out .'];' ."\n";

# ...and continue with HTML javascript stuff

print <<EOF;
        var ds = new Ext.data.Store({
		        proxy: new Ext.data.MemoryProxy(myData),
		        reader: new Ext.data.ArrayReader({}, [
                       {name: 'computer'},
                       {name: 'action_run'},
                       {name: 'mac_address'},
                       {name: 'action'},
                       {name: 'web_action'}
                  ])
        });
        ds.load();

		function bold(val){
				return '<B>' + val + '</B>';
		}


		// the DefaultColumnModel expects this blob to define columns. It can be extended to provide
        // custom or reusable ColumnModels
        var colModel = new Ext.grid.ColumnModel([
			{id: 'computer', header: "$lang_comp", width: 200, sortable: true, locked:false, dataIndex: 'computer' },
                        {header: "", width: 50, sortable: false, dataIndex: 'action_run'},
			{header: "$lang_mac", width: 150, sortable: true, locked:false, dataIndex: 'mac_address'},
			{header: "", width: 50, sortable: false, dataIndex: 'action'},
			{header: "web action", width: 150, hidden: true, sortable: false, dataIndex: 'web_action'}
		]);
		var sm=new Ext.grid.RowSelectionModel();


        // create the Grid
        var grid = new Ext.grid.Grid('content', {
            ds: ds,
            cm: colModel,
			sm: sm,
			listeners: { 'rowdblclick': function(g) {
				var r=sm.getSelected().data.web_action;
				var s=sm.getSelected().data.computer;
				var p=sm.getSelected().data.mac_address;
				if (r.charAt(r.length-1)>'0') {
					var q="$lang_wake <I>"+s+"</I>?";
				}
				Ext.MessageBox.show({
					title: '$lang_att',
					msg:q,
					buttons:Ext.MessageBox.YESNO,
					fn: function(btn) {
						if (btn=='yes') {
							Ext.MessageBox.show({
                                msg: '$lang_sent'+p,
                                wait: true,
                                width: 400,
                                waitConfig: {interval:3000}
                            });

							window.location=r ;
						}
					}
				});
				}
			},
            autoExpandColumn: 'computer'

        });

        var layout = Ext.BorderLayout.create({
            center: {
				titlebar:false,
				margins:{left:1,top:1,right:1,bottom:1},
                panels: [new Ext.GridPanel(grid)]
            }
        }, 'gridpanel');

        grid.render();
    }
};

Ext.onReady(Computer_list.init, Computer_list);
</script>

    <!-- Include Ext stylesheets here: -->
    <link rel="stylesheet" type="text/css" href="/scripts/extjs/resources/css/ext-all.css"><!-- AJAX stuff -->
    <link rel="stylesheet" type="text/css" href="/scripts/extjs/resources/css/xtheme-aero.css"><!-- Same shine theme Synology is using -->
</head>
<body style="margin: 1; padding: 1; text-align: left; font-family: Arial, Helvetica, sans-serif;">
    <div id="gridpanel" style="width:100%;height:500px;">
    <div id="content"></div></div>
    </div>
      <div id="bottom">
        <form id="add_computer" name="add_computer" method="post" action="index.cgi">
          <label>$lang_comp
            <input type="text" name="add_comp" id="add_comp" value="$err_copm" title="$lang_example $lang_example_comp" />
          </label>
          <label>$lang_mac
            <input type="text" name="add_mac" id="add_mac" value="$err_mac" title="$lang_example 0a:1b:3c:4d:5e:6f" />
          </label>
          <input type="submit" name="add" type="button" value="$lang_add" />
        </form>
      </div>
	  <div id="error">$error</div>
	  <div id="link">Version: $version | Updates: <a href="http://www.ruinelli.ch/syno_wol" target="_blank" style="color:#000">www.ruinelli.ch/syno_wol</a> | Original: <a href="http://www.diskstation.ru/viewtopic.php?f=30&t=137" target="_blank" style="color:#000">www.diskstation.ru</a></div>
</body>
</html>
EOF


if ($param_wol_mac)
{
	send_wakeup_packet($param_wol_mac);
}

sub send_wakeup_packet {
	($mac) = @_;
	# Remove colons
	$mac =~ tr/://d;
	# Magic packet is 6 bytes of FF followed by the MAC address 16 times
	$magic = ("\xff" x 6) . (pack('H12', $mac) x 16);
	# Create socket
	socket(S, PF_INET, SOCK_DGRAM, getprotobyname('udp'))
		or die "socket: $!\n";
	# Enable broadcast
	setsockopt(S, SOL_SOCKET, SO_BROADCAST, 1)
		or die "setsockopt: $!\n";
	# Send the wakeup packet
	defined(send(S, $magic, 0, sockaddr_in(0x2fff, INADDR_BROADCAST)))
		or print "send: $!\n";
	close(S);
}